<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 576 $
 * $Id: User.php 576 2007-01-29 19:55:33Z ipso $
 * $Date: 2007-01-29 11:55:33 -0800 (Mon, 29 Jan 2007) $
 */
require_once('../../includes/global.inc.php');

$authenticate=FALSE;
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

$title = '6. Administrator User';
$smarty->assign('title', $title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'company_id',
												'user_data'
												) ) );

$install_obj = new Install();
if ( $install_obj->isInstallMode() == FALSE ) {
	Redirect::Page( URLBuilder::getURL(NULL, 'install.php') );
}

$uf = new UserFactory();
switch (strtolower($action)) {
	case 'back':
		Debug::Text('Back', __FILE__, __LINE__, __METHOD__,10);

		Redirect::Page( URLBuilder::getURL(NULL, 'Company.php') );
		break;

	case 'next':
		//Debug::setVerbosity(11);
		Debug::Text('Submit!', __FILE__, __LINE__, __METHOD__,10);

		$uf->StartTransaction();
		$uf->setCompany( $user_data['company_id'] );
		$uf->setStatus( 10 );
		$uf->setUserName($user_data['user_name']);
		if ( !empty($user_data['password']) AND $user_data['password'] == $user_data['password2'] ) {
			$uf->setPassword($user_data['password']);
		} else {
			$uf->Validator->isTrue(	$uf->password_validator_label,
									FALSE,
									$uf->password_validator_match_msg);
		}

		$uf->setEmployeeNumber(1);
		$uf->setFirstName($user_data['first_name']);
		$uf->setLastName($user_data['last_name']);

		if ( $uf->isValid() ) {
			$user_id = $uf->Save();

			if ( $install_obj->isProfessionalEditionAvailable() == TRUE ) {
				$preset_flags = array(
									'job' => 1,
									'invoice' => 1,
									'document' => 1,
									);
			} else {
				$preset_flags = array();
			}
			//Set Full permissions for this user.
			$pf = new PermissionFactory();
			$pf->applyPreset( array($user_id) , 40, $preset_flags); //Administrator

			//Enable punching in from all stations
			$sf = new StationFactory();
			$sf->setCompany( $user_data['company_id'] );

			$sf->setStatus( 20 );
			$sf->setType( 10 );
			$sf->setSource( 'ANY' );
			$sf->setStation( 'ANY' );
			$sf->setDescription( 'All stations' );

			if ( $sf->isValid() ) {
				$sf->Save(FALSE);
				$sf->setUser( array(-1) );
				$sf->Save();
			}

			$uf->CommitTransaction();

			Redirect::Page( URLBuilder::getURL( NULL, 'MaintenanceJobs.php') );

			break;
		}
		$uf->FailTransaction();

	default:
		if ( isset($company_id) ) {
			$user_data['company_id'] = $company_id;
		}
		$smarty->assign_by_ref('user_data', $user_data);

		break;
}

$handle = fopen('http://www.timetrex.com/'.URLBuilder::getURL( array('v' => $install_obj->getFullApplicationVersion(), 'page' => 'user'), 'pre_install.php'), "r");
fclose($handle);

$smarty->assign_by_ref('uf', $uf);

$smarty->display('install/User.tpl');
?>